Home | History | Annotate | Download | only in rbind
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test37} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST37***************"
     29 tst_resm TINFO "rbind: private to private - with shared children."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of rbind/test37 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	mkdir parent1 parent2
     44 	"${FS_BIND_ROOT}/bin/makedir" share share1
     45 	"${FS_BIND_ROOT}/bin/makedir" share share2
     46 	"${FS_BIND_ROOT}/bin/makedir" share parent1/child1
     47 	"${FS_BIND_ROOT}/bin/makedir" share parent2/child2
     48 
     49 	mount --bind "$disk1" parent1/child1
     50 	mount --rbind parent1/child1 share1
     51 
     52 	mount --rbind parent2/child2 share2
     53 
     54 	mount --rbind parent1 parent2
     55 
     56 	check parent1 parent2
     57 	check parent1/child1 parent2/child1
     58 
     59 	mount --bind "$disk2" parent2/child1/a
     60 	check parent1/child1/a parent2/child1/a share1//a
     61 
     62 	mount --bind "$disk3" parent1/child1/b
     63 	check parent1/child1/b parent2/child1/b share1/b
     64 
     65 	mount --bind "$disk4" share1/c
     66 	check parent1/child1/c parent2/child1/c share1/c
     67 
     68 	break
     69 done
     70 trap 'ERR=$? ; tst_resm TWARN "rbind/test37: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     71 if [ -n "${ERR_MSG}" ]; then
     72 	tst_resm TWARN "rbind/test37: ${ERR_MSG}"
     73 	ERR_MSG=""
     74 	result=$ERR
     75 fi
     76 trap '' ERR
     77 {
     78 	umount parent1/child1/a
     79 	umount parent1/child1/b
     80 	umount share1/c
     81 	umount parent2/child1
     82 	umount parent2/child1
     83 	umount parent1/child1
     84 	umount parent2
     85 	umount share2
     86 	umount share2
     87 	umount share1
     88 	umount share1
     89 	umount parent2/child2
     90 
     91 	rm -rf parent* share*
     92 	cleanup
     93 } >& /dev/null
     94 if [ $result -ne 0 ]
     95 then
     96 	tst_resm TFAIL "rbind/test37: FAILED: rbind: private to private - with shared children."
     97 	exit 1
     98 else
     99 	tst_resm TPASS "rbind/test37: PASSED"
    100 	exit 0
    101 fi
    102 tst_exit
    103